# Class VulkanDescriptorSetLayoutCreateInfo

java.lang.Object
com.io7m.jcoronado.api.VulkanDescriptorSetLayoutCreateInfo

All Implemented Interfaces:
  `VulkanDescriptorSetLayoutCreateInfoType`

public final class VulkanDescriptorSetLayoutCreateInfo extends Object implements VulkanDescriptorSetLayoutCreateInfoType

See Also:
  - "VkDescriptorSetLayoutCreateInfo"

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `VulkanDescriptorSetLayoutCreateInfo.Builder`
  Builds instances of type `VulkanDescriptorSetLayoutCreateInfo`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `List<VulkanDescriptorSetLayoutBinding>`
  `bindings()`
  `static VulkanDescriptorSetLayoutCreateInfo.Builder`
  `builder()`
  Creates a builder for `VulkanDescriptorSetLayoutCreateInfo`.
  `static VulkanDescriptorSetLayoutCreateInfo`
  `copyOf(VulkanDescriptorSetLayoutCreateInfoType instance)`
  Creates an immutable copy of a `VulkanDescriptorSetLayoutCreateInfoType` value.
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `VulkanDescriptorSetLayoutCreateInfo` that have equal attribute values.
  `Set<VulkanDescriptorSetLayoutCreateFlag>`
  `flags()`
  `int`
  `hashCode()`
  Computes a hash code from attributes: `flags`, `bindings`.
  `static VulkanDescriptorSetLayoutCreateInfo`
  `of(Iterable<VulkanDescriptorSetLayoutCreateFlag> flags, Iterable<? extends VulkanDescriptorSetLayoutBinding> bindings)`
  Construct a new immutable `VulkanDescriptorSetLayoutCreateInfo` instance.
  `static VulkanDescriptorSetLayoutCreateInfo`
  `of(Set<VulkanDescriptorSetLayoutCreateFlag> flags, List<VulkanDescriptorSetLayoutBinding> bindings)`
  Construct a new immutable `VulkanDescriptorSetLayoutCreateInfo` instance.
  `String`
  `toString()`
  Prints the immutable value `VulkanDescriptorSetLayoutCreateInfo` with attribute values.
  `final VulkanDescriptorSetLayoutCreateInfo`
  `withBindings(VulkanDescriptorSetLayoutBinding... elements)`
  Copy the current immutable object with elements that replace the content of `bindings`.
  `final VulkanDescriptorSetLayoutCreateInfo`
  `withBindings(Iterable<? extends VulkanDescriptorSetLayoutBinding> elements)`
  Copy the current immutable object with elements that replace the content of `bindings`.
  `final VulkanDescriptorSetLayoutCreateInfo`
  `withFlags(VulkanDescriptorSetLayoutCreateFlag... elements)`
  Copy the current immutable object with elements that replace the content of `flags`.
  `final VulkanDescriptorSetLayoutCreateInfo`
  `withFlags(Iterable<VulkanDescriptorSetLayoutCreateFlag> elements)`
  Copy the current immutable object with elements that replace the content of `flags`.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### flags

    public Set<VulkanDescriptorSetLayoutCreateFlag> flags()
    Specified by:
      `flags` in interface `VulkanDescriptorSetLayoutCreateInfoType`
    Returns:
      A bitmask of VulkanDescriptorSetLayoutCreateFlag values specifying options for descriptor set layout creation.

  - ### bindings

    public List<VulkanDescriptorSetLayoutBinding> bindings()
    Specified by:
      `bindings` in interface `VulkanDescriptorSetLayoutCreateInfoType`
    Returns:
      An array of VulkanDescriptorSetLayoutBinding structures.

  - ### withFlags

    public final VulkanDescriptorSetLayoutCreateInfo withFlags(VulkanDescriptorSetLayoutCreateFlag... elements)
    Copy the current immutable object with elements that replace the content of `flags`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withFlags

    public final VulkanDescriptorSetLayoutCreateInfo withFlags(Iterable<VulkanDescriptorSetLayoutCreateFlag> elements)
    Copy the current immutable object with elements that replace the content of `flags`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of flags elements to set
    Returns:
      A modified copy of `this` object

  - ### withBindings

    public final VulkanDescriptorSetLayoutCreateInfo withBindings(VulkanDescriptorSetLayoutBinding... elements)
    Copy the current immutable object with elements that replace the content of `bindings`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withBindings

    public final VulkanDescriptorSetLayoutCreateInfo withBindings(Iterable<? extends VulkanDescriptorSetLayoutBinding> elements)
    Copy the current immutable object with elements that replace the content of `bindings`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of bindings elements to set
    Returns:
      A modified copy of `this` object

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `VulkanDescriptorSetLayoutCreateInfo` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `flags`, `bindings`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `VulkanDescriptorSetLayoutCreateInfo` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### of

    public static VulkanDescriptorSetLayoutCreateInfo of(Set<VulkanDescriptorSetLayoutCreateFlag> flags, List<VulkanDescriptorSetLayoutBinding> bindings)
    Construct a new immutable `VulkanDescriptorSetLayoutCreateInfo` instance.
    Parameters:
      `flags` - The value for the `flags` attribute
      `bindings` - The value for the `bindings` attribute
    Returns:
      An immutable VulkanDescriptorSetLayoutCreateInfo instance

  - ### of

    public static VulkanDescriptorSetLayoutCreateInfo of(Iterable<VulkanDescriptorSetLayoutCreateFlag> flags, Iterable<? extends VulkanDescriptorSetLayoutBinding> bindings)
    Construct a new immutable `VulkanDescriptorSetLayoutCreateInfo` instance.
    Parameters:
      `flags` - The value for the `flags` attribute
      `bindings` - The value for the `bindings` attribute
    Returns:
      An immutable VulkanDescriptorSetLayoutCreateInfo instance

  - ### copyOf

    public static VulkanDescriptorSetLayoutCreateInfo copyOf(VulkanDescriptorSetLayoutCreateInfoType instance)
    Creates an immutable copy of a `VulkanDescriptorSetLayoutCreateInfoType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable VulkanDescriptorSetLayoutCreateInfo instance

  - ### builder

    public static VulkanDescriptorSetLayoutCreateInfo.Builder builder()
    Creates a builder for `VulkanDescriptorSetLayoutCreateInfo`.

         VulkanDescriptorSetLayoutCreateInfo.builder()
            .addFlags|addAllFlags(com.io7m.jcoronado.api.VulkanDescriptorSetLayoutCreateFlag) // flags elements
            .addBindings|addAllBindings(VulkanDescriptorSetLayoutBinding) // bindings elements
            .build();

    Returns:
      A new VulkanDescriptorSetLayoutCreateInfo builder